const std = @import("std");

pub const MathOperation = enum {
    Division,
    Power,
    Root,
};

pub fn calculate(first: f32, second: f32, op: MathOperation) !f32 {
    switch (op) {
        .Division => {
            if (second == 0) {
                return error.InvalidParam;
            }
            return first / second;
        },
        .Power => {
            if (first == 0 and second < 0) {
                return error.InvalidParam;
            }
            return std.math.pow(f32, first, second);
        },
        .Root => {
            if (first < 0 or second < 0) {
                return error.InvalidParam;
            }
            return std.math.sqrt(second);
        },
    }
}

fn abs(a: f32) f32 {
    if (a < 0) {
        return -a;
    }

    return a;
}
